import { world, system, Player, BlockPermutation, ItemStack, EquipmentSlot } from "@minecraft/server";

// Star Sword
export function StarLight() {
    world.afterEvents.itemUse.subscribe(({ source }) => {
        const equippable = source.getComponent("equippable");
        const item = equippable.getEquipment(EquipmentSlot.Mainhand);
        if (!item) return;
        switch (item.typeId) {
            case "dancing_blades:starlight": // Star
                if (item.typeId === "dancing_blades:starlight" && !source.hasTag('cooldown_sword_basic') && source.isOnGround) {
                    source.runCommandAsync('function starlight');
                    source.addTag('cooldown_sword_basic');
                    break;
                }

        }
    });
}

// Fireb Sword
export function Fireb() {
    world.afterEvents.itemUse.subscribe(({ source }) => {
        const equippable = source.getComponent("equippable");
        const item = equippable.getEquipment(EquipmentSlot.Mainhand);
        if (!item) return;
        switch (item.typeId) {
            case "dancing_blades:firebrand_blade": // Fireb
                if (item.typeId === "dancing_blades:firebrand_blade" && !source.hasTag('cooldown_sword_basic') && source.isOnGround) {
                    source.runCommandAsync('function firebrand');
                    source.addTag('cooldown_sword_basic');
                    break;
                }

        }
    });
}

// torment
export function Torment() {
    world.afterEvents.itemUse.subscribe(({ source }) => {
        const equippable = source.getComponent("equippable");
        const item = equippable.getEquipment(EquipmentSlot.Mainhand);
        if (!item) return;
        switch (item.typeId) {
            case "dancing_blades:tormented_holographic_claymore": // torment
                if (item.typeId === "dancing_blades:tormented_holographic_claymore" && !source.hasTag('cooldown_sword_basic') && source.isOnGround) {
                    source.runCommandAsync('function torment');
                    source.addTag('cooldown_sword_basic');
                    break;
                }

        }
    });
}

// tp_blast
export function Tp_blast() {
    world.afterEvents.itemUse.subscribe(({ source }) => {
        const equippable = source.getComponent("equippable");
        const item = equippable.getEquipment(EquipmentSlot.Mainhand);
        if (!item) return;
        switch (item.typeId) {
            case "dancing_blades:holographic_endersteel_sword": // tp_blast
                if (item.typeId === "dancing_blades:holographic_endersteel_sword" && !source.hasTag('cooldown_sword_basic') && source.isOnGround) {
                    source.runCommandAsync('function tp_blast');
                    source.addTag('cooldown_sword_basic');
                    break;
                }

        }
    });
}

// Vex_blast
export function Vex_blast() {
    world.afterEvents.itemUse.subscribe(({ source }) => {
        const equippable = source.getComponent("equippable");
        const item = equippable.getEquipment(EquipmentSlot.Mainhand);
        if (!item) return;
        switch (item.typeId) {
            case "dancing_blades:corruption_blade": // Vex_blast
                if (item.typeId === "dancing_blades:corruption_blade" && !source.hasTag('cooldown_sword_basic') && source.isOnGround) {
                    source.runCommandAsync('function vex_bomb');
                    source.addTag('cooldown_sword_basic');
                    break;
                }

        }
    });
}

// eternal_mine
export function Eternal_mine() {
    world.afterEvents.itemUse.subscribe(({ source }) => {
        const equippable = source.getComponent("equippable");
        const item = equippable.getEquipment(EquipmentSlot.Mainhand);
        if (!item) return;
        switch (item.typeId) {
            case "dancing_blades:eternal_sword": // eternal_mine
                if (item.typeId === "dancing_blades:eternal_sword" && !source.hasTag('cooldown_sword_basic') && source.isOnGround) {
                    source.runCommandAsync('function eternal_sword');
                    source.addTag('cooldown_sword_basic');
                    break;
                }

        }
    });
}

// holo_hit
export function Holo_hit() {
    world.afterEvents.itemUse.subscribe(({ source }) => {
        const equippable = source.getComponent("equippable");
        const item = equippable.getEquipment(EquipmentSlot.Mainhand);
        if (!item) return;
        switch (item.typeId) {
            case "dancing_blades:holographic_blade": // holo
                if (item.typeId === "dancing_blades:holographic_blade" && !source.hasTag('cooldown_sword_basic') && source.isOnGround) {
                    source.runCommandAsync('function holo');
                    source.addTag('cooldown_sword_basic');
                    break;
                }

        }
    });
}